Ltac genclear H := generalize H;clear H.
Ltac map_hyp Tac :=
  repeat match goal with
    | [ H : _ |- _ ] => try (Tac H);genclear H
    end; intros.

Inductive Plist : Prop :=
  | Pnil : Plist
  | Pcons : Prop -> Plist -> Plist.

Ltac build_imp Pl C :=
  match Pl with
  | Pnil => constr:C
  | Pcons ?A ?Pl' =>
        let C' := constr:(A->C) in
        build_imp Pl' C'
  end.

Inductive PPlProd : Prop :=
 | PPlPair : Plist -> Prop -> PPlProd.

Ltac elim_aT Pl T :=
  match T with
  | ?A /\ ?B =>
      let A' := elim_aT Pl A in
      let B' := elim_aT Pl B in
      constr:(A' /\ B')
  | ?A => build_imp Pl T
  end.

Ltac elim_iaT Pl T :=
   match T with
   | (?B /\ ?C) =>
        let P := elim_aT Pl T in
        constr:(PPlPair Pl P)
   | (?A -> ?D) =>
        let Pl' := constr:(Pcons A Pl) in
        elim_iaT Pl' D
   end.

Ltac splitAndH H :=
  match type of H with
  | ?A /\ ?B =>
             case H;clear H;
	     let H1 := fresh "H" in
	     let H2 := fresh "H" in
	     (intros H1 H2; splitAndH H1; splitAndH H2)
  | _ => idtac
  end.

Ltac introPl Pl H := 
 match Pl with
 | Pnil => splitAndH H
 | Pcons _ ?pl => 
     let H1 := fresh "H" in
     let H2 := fresh "H" in 
     (intro H1;assert (H2 := H H1);introPl pl H2)
 end.

Ltac splitAnd := 
  match goal with
  | [|- ?A /\ ?B] => split;splitAnd
  | _ => idtac
  end.

Ltac elimAnd :=
  match goal with
  | [H : ? A /\ ?B |- _ ] =>
             case H;clear H;
	     let H1 := fresh "H" in
	     let H2 := fresh "H" in
	     intros H1 H2; elimAnd
  | [H : ?HT|- _ ] =>
       let pair := elim_iaT Pnil HT in
       match pair with
       | PPlPair ?Pl ?newT =>
         assert newT;
         [splitAnd; introPl Pl H;trivial
         | clear H;elimAnd]
       end
  | [H: _ |- _ ] => genclear H;elimAnd
  | _ => intros; repeat match goal with [H: _ |- _ /\ _] => split end
  end.


Ltac simplOr_rec h name tail :=
	match h with
	|    ?A \/ ?B -> ?C  => assert(tail -> A -> C); [intros; apply name;trivial; left;trivial| idtac];
	                                                assert(tail -> B -> C); [intros; apply name; trivial; right;trivial| idtac]; clear name
	|    ?A -> ?B => simplOr_rec B name (tail -> A)
	end.

Ltac simplOr_im h name :=
	match h with
	|    ?A \/ ?B -> ?C  => assert(A -> C); [intros; apply name; left;trivial| idtac];
	                                                assert(B -> C); [intros; apply name; right;trivial| idtac]; clear name
	|    ?A -> ?B => simplOr_rec B name A
	end.

Ltac simplOr := 
	repeat match goal with
	|   [H: ?A |- _] =>simplOr_im A H
	end.
(* Variable a: Prop.
Variable b: Prop.
Variable h:(a -> a \/ b -> a) .
Lemma l1 :  (a -> b -> a).
intros.
apply h.
assumption.
right.
assumption.
Qed. Print l1. *)
Definition toto := fun (a : Prop) => (fun (H : a) => H).
Print toto.   
Lemma l : forall a b c: Prop, c ->
(not a) /\(a \/ b \/ c)  ->((a \/ b \/ c) -> ((a \/ c)-> (not a /\a)))  -> c.
Proof.
intros.
(* assert(h : a\/ b \/ c-> c -> (not a) /\ a). *)
(* apply (fun  (h: a \/ b) (h1: c) => H1 h (or_intror a h1)). *)

(* assert(h1 : a -> a \/ c-> (not a) /\ a). *)
(* assert(h2 := (fun  (h11: a) => H1  (or_introl b h11))). *)
assert(h := fun (h: (a \/ b\/ c)) (h1: (a\/ c)) =>let h2 := H1 h h1  in  match h2 with conj  A _ => A end).
assert(h' := fun (h: (a \/ b\/ c)) (h1: (a\/ c)) =>let h2 := H1 h h1  in  match h2 with conj   _ B => B end).
elimand.
elimor.
assumption.
Qed.

Print l.